<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">SDL.GPU.Simple.Rendering</span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-2"></span><span>
</span><span id="line-3"></span><span>
</span><span id="line-4"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.Word</span></span><span>
</span><span id="line-5"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.Void</span></span><span>
</span><span id="line-6"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Ptr</span></span><span>
</span><span id="line-7"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Marshal.Utils</span></span><span>
</span><span id="line-8"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Control.Monad.IO.Class</span></span><span>
</span><span id="line-9"></span><span>
</span><span id="line-10"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.C.html"><span class="hs-identifier">SDL.GPU.C</span></a></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">GPU</span></span><span>
</span><span id="line-11"></span><span>
</span><span id="line-12"></span><span class="annot"><a href="SDL.GPU.Simple.Rendering.html#clear"><span class="hs-identifier hs-type">clear</span></a></span><span>
</span><span id="line-13"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190915"><span class="annot"><a href="#local-6989586621679190915"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-14"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190915"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-15"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-16"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190915"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-17"></span><span id="clear"><span class="annot"><span class="annottext">clear :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; m ()
</span><a href="SDL.GPU.Simple.Rendering.html#clear"><span class="hs-identifier hs-var hs-var">clear</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; IO ()
</span><a href="SDL.GPU.C.Rendering.html#clear"><span class="hs-identifier hs-var">GPU.clear</span></a></span><span>
</span><span id="line-18"></span><span>
</span><span id="line-19"></span><span class="annot"><a href="SDL.GPU.Simple.Rendering.html#clearColor"><span class="hs-identifier hs-type">clearColor</span></a></span><span>
</span><span id="line-20"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190906"><span class="annot"><a href="#local-6989586621679190906"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-21"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190906"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-22"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-23"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">GPU.Color</span></span><span>
</span><span id="line-24"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190906"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-25"></span><span id="clearColor"><span class="annot"><span class="annottext">clearColor :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; Color -&gt; m ()
</span><a href="SDL.GPU.Simple.Rendering.html#clearColor"><span class="hs-identifier hs-var hs-var">clearColor</span></a></span></span><span> </span><span id="local-6989586621679190862"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679190862"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span id="local-6989586621679190861"><span class="annot"><span class="annottext">Color
</span><a href="#local-6989586621679190861"><span class="hs-identifier hs-var">c</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; a -&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">with</span></span><span> </span><span class="annot"><span class="annottext">Color
</span><a href="#local-6989586621679190861"><span class="hs-identifier hs-var">c</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679190859"><span class="annot"><span class="annottext">Ptr Color
</span><a href="#local-6989586621679190859"><span class="hs-identifier hs-var">pc</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; Ptr Color -&gt; IO ()
</span><a href="SDL.GPU.C.Rendering.html#clearColor"><span class="hs-identifier hs-var">GPU.clearColor</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679190862"><span class="hs-identifier hs-var">t</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Color
</span><a href="#local-6989586621679190859"><span class="hs-identifier hs-var">pc</span></a></span><span>
</span><span id="line-26"></span><span>
</span><span id="line-27"></span><span class="annot"><a href="SDL.GPU.Simple.Rendering.html#blit"><span class="hs-identifier hs-type">blit</span></a></span><span>
</span><span id="line-28"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190897"><span class="annot"><a href="#local-6989586621679190897"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-29"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190897"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-30"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-31"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Maybe</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Rect"><span class="hs-identifier hs-type">GPU.Rect</span></a></span><span>
</span><span id="line-32"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-33"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ x</span><span>
</span><span id="line-34"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ y</span><span>
</span><span id="line-35"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190897"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-36"></span><span id="blit"><span class="annot"><span class="annottext">blit :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr Image -&gt; Maybe Rect -&gt; Ptr Target -&gt; Float -&gt; Float -&gt; m ()
</span><a href="SDL.GPU.Simple.Rendering.html#blit"><span class="hs-identifier hs-var hs-var">blit</span></a></span></span><span> </span><span id="local-6989586621679190852"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190852"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679190851"><span class="annot"><span class="annottext">Maybe Rect
</span><a href="#local-6989586621679190851"><span class="hs-identifier hs-var">rect</span></a></span></span><span> </span><span id="local-6989586621679190850"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679190850"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span id="local-6989586621679190849"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190849"><span class="hs-identifier hs-var">x</span></a></span></span><span> </span><span id="local-6989586621679190848"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190848"><span class="hs-identifier hs-var">y</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall a b c.
(a -&gt; (Ptr b -&gt; IO c) -&gt; IO c)
-&gt; Maybe a -&gt; (Ptr b -&gt; IO c) -&gt; IO c
</span><span class="hs-identifier hs-var">maybeWith</span></span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; a -&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">with</span></span><span> </span><span class="annot"><span class="annottext">Maybe Rect
</span><a href="#local-6989586621679190851"><span class="hs-identifier hs-var">rect</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679190846"><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190846"><span class="hs-identifier hs-var">pr</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-37"></span><span>  </span><span class="annot"><span class="annottext">Ptr Image -&gt; Ptr Rect -&gt; Ptr Target -&gt; Float -&gt; Float -&gt; IO ()
</span><a href="SDL.GPU.C.Rendering.html#blit"><span class="hs-identifier hs-var">GPU.blit</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190852"><span class="hs-identifier hs-var">img</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190846"><span class="hs-identifier hs-var">pr</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679190850"><span class="hs-identifier hs-var">t</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190849"><span class="hs-identifier hs-var">x</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190848"><span class="hs-identifier hs-var">y</span></a></span><span>
</span><span id="line-38"></span><span>
</span><span id="line-39"></span><span class="annot"><a href="SDL.GPU.Simple.Rendering.html#blitRotate"><span class="hs-identifier hs-type">blitRotate</span></a></span><span>
</span><span id="line-40"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190889"><span class="annot"><a href="#local-6989586621679190889"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-41"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190889"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-42"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-43"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Maybe</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Rect"><span class="hs-identifier hs-type">GPU.Rect</span></a></span><span>
</span><span id="line-44"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-45"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ x</span><span>
</span><span id="line-46"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ y</span><span>
</span><span id="line-47"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ degrees</span><span>
</span><span id="line-48"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190889"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-49"></span><span id="blitRotate"><span class="annot"><span class="annottext">blitRotate :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr Image
-&gt; Maybe Rect -&gt; Ptr Target -&gt; Float -&gt; Float -&gt; Float -&gt; m ()
</span><a href="SDL.GPU.Simple.Rendering.html#blitRotate"><span class="hs-identifier hs-var hs-var">blitRotate</span></a></span></span><span> </span><span id="local-6989586621679190840"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190840"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679190839"><span class="annot"><span class="annottext">Maybe Rect
</span><a href="#local-6989586621679190839"><span class="hs-identifier hs-var">rect</span></a></span></span><span> </span><span id="local-6989586621679190838"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679190838"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span id="local-6989586621679190837"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190837"><span class="hs-identifier hs-var">x</span></a></span></span><span> </span><span id="local-6989586621679190836"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190836"><span class="hs-identifier hs-var">y</span></a></span></span><span> </span><span id="local-6989586621679190835"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190835"><span class="hs-identifier hs-var">d</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall a b c.
(a -&gt; (Ptr b -&gt; IO c) -&gt; IO c)
-&gt; Maybe a -&gt; (Ptr b -&gt; IO c) -&gt; IO c
</span><span class="hs-identifier hs-var">maybeWith</span></span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; a -&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">with</span></span><span> </span><span class="annot"><span class="annottext">Maybe Rect
</span><a href="#local-6989586621679190839"><span class="hs-identifier hs-var">rect</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679190834"><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190834"><span class="hs-identifier hs-var">pr</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-50"></span><span>  </span><span class="annot"><span class="annottext">Ptr Image
-&gt; Ptr Rect -&gt; Ptr Target -&gt; Float -&gt; Float -&gt; Float -&gt; IO ()
</span><a href="SDL.GPU.C.Rendering.html#blitRotate"><span class="hs-identifier hs-var">GPU.blitRotate</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190840"><span class="hs-identifier hs-var">img</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190834"><span class="hs-identifier hs-var">pr</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679190838"><span class="hs-identifier hs-var">t</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190837"><span class="hs-identifier hs-var">x</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190836"><span class="hs-identifier hs-var">y</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190835"><span class="hs-identifier hs-var">d</span></a></span><span>
</span><span id="line-51"></span><span>
</span><span id="line-52"></span><span class="annot"><a href="SDL.GPU.Simple.Rendering.html#blitScale"><span class="hs-identifier hs-type">blitScale</span></a></span><span>
</span><span id="line-53"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190887"><span class="annot"><a href="#local-6989586621679190887"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-54"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190887"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-55"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-56"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Maybe</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Rect"><span class="hs-identifier hs-type">GPU.Rect</span></a></span><span>
</span><span id="line-57"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-58"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ x</span><span>
</span><span id="line-59"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ y</span><span>
</span><span id="line-60"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ scaleX</span><span>
</span><span id="line-61"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ scaleY</span><span>
</span><span id="line-62"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190887"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-63"></span><span id="blitScale"><span class="annot"><span class="annottext">blitScale :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr Image
-&gt; Maybe Rect
-&gt; Ptr Target
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; m ()
</span><a href="SDL.GPU.Simple.Rendering.html#blitScale"><span class="hs-identifier hs-var hs-var">blitScale</span></a></span></span><span> </span><span id="local-6989586621679190828"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190828"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679190827"><span class="annot"><span class="annottext">Maybe Rect
</span><a href="#local-6989586621679190827"><span class="hs-identifier hs-var">rect</span></a></span></span><span> </span><span id="local-6989586621679190826"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679190826"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span id="local-6989586621679190825"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190825"><span class="hs-identifier hs-var">x</span></a></span></span><span> </span><span id="local-6989586621679190824"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190824"><span class="hs-identifier hs-var">y</span></a></span></span><span> </span><span id="local-6989586621679190823"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190823"><span class="hs-identifier hs-var">sx</span></a></span></span><span> </span><span id="local-6989586621679190822"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190822"><span class="hs-identifier hs-var">sy</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall a b c.
(a -&gt; (Ptr b -&gt; IO c) -&gt; IO c)
-&gt; Maybe a -&gt; (Ptr b -&gt; IO c) -&gt; IO c
</span><span class="hs-identifier hs-var">maybeWith</span></span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; a -&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">with</span></span><span> </span><span class="annot"><span class="annottext">Maybe Rect
</span><a href="#local-6989586621679190827"><span class="hs-identifier hs-var">rect</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679190821"><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190821"><span class="hs-identifier hs-var">pr</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-64"></span><span>  </span><span class="annot"><span class="annottext">Ptr Image
-&gt; Ptr Rect
-&gt; Ptr Target
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; IO ()
</span><a href="SDL.GPU.C.Rendering.html#blitScale"><span class="hs-identifier hs-var">GPU.blitScale</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190828"><span class="hs-identifier hs-var">img</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190821"><span class="hs-identifier hs-var">pr</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679190826"><span class="hs-identifier hs-var">t</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190825"><span class="hs-identifier hs-var">x</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190824"><span class="hs-identifier hs-var">y</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190823"><span class="hs-identifier hs-var">sx</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190822"><span class="hs-identifier hs-var">sy</span></a></span><span>
</span><span id="line-65"></span><span>
</span><span id="line-66"></span><span class="annot"><a href="SDL.GPU.Simple.Rendering.html#blitTransform"><span class="hs-identifier hs-type">blitTransform</span></a></span><span>
</span><span id="line-67"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190885"><span class="annot"><a href="#local-6989586621679190885"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-68"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190885"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-69"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-70"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Maybe</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Rect"><span class="hs-identifier hs-type">GPU.Rect</span></a></span><span>
</span><span id="line-71"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-72"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ x</span><span>
</span><span id="line-73"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ y</span><span>
</span><span id="line-74"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ degrees</span><span>
</span><span id="line-75"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ scaleX</span><span>
</span><span id="line-76"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ scaleY</span><span>
</span><span id="line-77"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190885"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-78"></span><span id="blitTransform"><span class="annot"><span class="annottext">blitTransform :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr Image
-&gt; Maybe Rect
-&gt; Ptr Target
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; m ()
</span><a href="SDL.GPU.Simple.Rendering.html#blitTransform"><span class="hs-identifier hs-var hs-var">blitTransform</span></a></span></span><span> </span><span id="local-6989586621679190815"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190815"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679190814"><span class="annot"><span class="annottext">Maybe Rect
</span><a href="#local-6989586621679190814"><span class="hs-identifier hs-var">rect</span></a></span></span><span> </span><span id="local-6989586621679190813"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679190813"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span id="local-6989586621679190812"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190812"><span class="hs-identifier hs-var">x</span></a></span></span><span> </span><span id="local-6989586621679190811"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190811"><span class="hs-identifier hs-var">y</span></a></span></span><span> </span><span id="local-6989586621679190810"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190810"><span class="hs-identifier hs-var">d</span></a></span></span><span> </span><span id="local-6989586621679190809"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190809"><span class="hs-identifier hs-var">sx</span></a></span></span><span> </span><span id="local-6989586621679190808"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190808"><span class="hs-identifier hs-var">sy</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall a b c.
(a -&gt; (Ptr b -&gt; IO c) -&gt; IO c)
-&gt; Maybe a -&gt; (Ptr b -&gt; IO c) -&gt; IO c
</span><span class="hs-identifier hs-var">maybeWith</span></span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; a -&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">with</span></span><span> </span><span class="annot"><span class="annottext">Maybe Rect
</span><a href="#local-6989586621679190814"><span class="hs-identifier hs-var">rect</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679190807"><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190807"><span class="hs-identifier hs-var">pr</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-79"></span><span>  </span><span class="annot"><span class="annottext">Ptr Image
-&gt; Ptr Rect
-&gt; Ptr Target
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; IO ()
</span><a href="SDL.GPU.C.Rendering.html#blitTransform"><span class="hs-identifier hs-var">GPU.blitTransform</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190815"><span class="hs-identifier hs-var">img</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190807"><span class="hs-identifier hs-var">pr</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679190813"><span class="hs-identifier hs-var">t</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190812"><span class="hs-identifier hs-var">x</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190811"><span class="hs-identifier hs-var">y</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190810"><span class="hs-identifier hs-var">d</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190809"><span class="hs-identifier hs-var">sx</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190808"><span class="hs-identifier hs-var">sy</span></a></span><span>
</span><span id="line-80"></span><span>
</span><span id="line-81"></span><span class="annot"><a href="SDL.GPU.Simple.Rendering.html#blitTransformX"><span class="hs-identifier hs-type">blitTransformX</span></a></span><span>
</span><span id="line-82"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190883"><span class="annot"><a href="#local-6989586621679190883"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-83"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190883"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-84"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-85"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Maybe</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Rect"><span class="hs-identifier hs-type">GPU.Rect</span></a></span><span>
</span><span id="line-86"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-87"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ x</span><span>
</span><span id="line-88"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ y</span><span>
</span><span id="line-89"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ pivot_x</span><span>
</span><span id="line-90"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ pivot_y</span><span>
</span><span id="line-91"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ degrees</span><span>
</span><span id="line-92"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ scaleX</span><span>
</span><span id="line-93"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ scaleY</span><span>
</span><span id="line-94"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190883"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-95"></span><span id="blitTransformX"><span class="annot"><span class="annottext">blitTransformX :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr Image
-&gt; Maybe Rect
-&gt; Ptr Target
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; m ()
</span><a href="SDL.GPU.Simple.Rendering.html#blitTransformX"><span class="hs-identifier hs-var hs-var">blitTransformX</span></a></span></span><span> </span><span id="local-6989586621679190801"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190801"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679190800"><span class="annot"><span class="annottext">Maybe Rect
</span><a href="#local-6989586621679190800"><span class="hs-identifier hs-var">rect</span></a></span></span><span> </span><span id="local-6989586621679190799"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679190799"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span id="local-6989586621679190798"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190798"><span class="hs-identifier hs-var">x</span></a></span></span><span> </span><span id="local-6989586621679190797"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190797"><span class="hs-identifier hs-var">y</span></a></span></span><span> </span><span id="local-6989586621679190796"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190796"><span class="hs-identifier hs-var">px</span></a></span></span><span> </span><span id="local-6989586621679190795"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190795"><span class="hs-identifier hs-var">py</span></a></span></span><span> </span><span id="local-6989586621679190794"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190794"><span class="hs-identifier hs-var">d</span></a></span></span><span> </span><span id="local-6989586621679190793"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190793"><span class="hs-identifier hs-var">sx</span></a></span></span><span> </span><span id="local-6989586621679190792"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190792"><span class="hs-identifier hs-var">sy</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall a b c.
(a -&gt; (Ptr b -&gt; IO c) -&gt; IO c)
-&gt; Maybe a -&gt; (Ptr b -&gt; IO c) -&gt; IO c
</span><span class="hs-identifier hs-var">maybeWith</span></span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; a -&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">with</span></span><span> </span><span class="annot"><span class="annottext">Maybe Rect
</span><a href="#local-6989586621679190800"><span class="hs-identifier hs-var">rect</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679190791"><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190791"><span class="hs-identifier hs-var">pr</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-96"></span><span>  </span><span class="annot"><span class="annottext">Ptr Image
-&gt; Ptr Rect
-&gt; Ptr Target
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; IO ()
</span><a href="SDL.GPU.C.Rendering.html#blitTransformX"><span class="hs-identifier hs-var">GPU.blitTransformX</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190801"><span class="hs-identifier hs-var">img</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190791"><span class="hs-identifier hs-var">pr</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679190799"><span class="hs-identifier hs-var">t</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190798"><span class="hs-identifier hs-var">x</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190797"><span class="hs-identifier hs-var">y</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190796"><span class="hs-identifier hs-var">px</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190795"><span class="hs-identifier hs-var">py</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190794"><span class="hs-identifier hs-var">d</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190793"><span class="hs-identifier hs-var">sx</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190792"><span class="hs-identifier hs-var">sy</span></a></span><span>
</span><span id="line-97"></span><span>
</span><span id="line-98"></span><span class="annot"><a href="SDL.GPU.Simple.Rendering.html#blitRect"><span class="hs-identifier hs-type">blitRect</span></a></span><span>
</span><span id="line-99"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190881"><span class="annot"><a href="#local-6989586621679190881"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-100"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190881"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-101"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-102"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Rect"><span class="hs-identifier hs-type">GPU.Rect</span></a></span><span> </span><span class="hs-comment">-- ^ src_rect</span><span>
</span><span id="line-103"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-104"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Rect"><span class="hs-identifier hs-type">GPU.Rect</span></a></span><span> </span><span class="hs-comment">-- ^ dest_rect</span><span>
</span><span id="line-105"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190881"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-106"></span><span id="blitRect"><span class="annot"><span class="annottext">blitRect :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr Image -&gt; Rect -&gt; Ptr Target -&gt; Rect -&gt; m ()
</span><a href="SDL.GPU.Simple.Rendering.html#blitRect"><span class="hs-identifier hs-var hs-var">blitRect</span></a></span></span><span> </span><span id="local-6989586621679190784"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190784"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679190783"><span class="annot"><span class="annottext">Rect
</span><a href="#local-6989586621679190783"><span class="hs-identifier hs-var">src_rect</span></a></span></span><span> </span><span id="local-6989586621679190782"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679190782"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span id="local-6989586621679190781"><span class="annot"><span class="annottext">Rect
</span><a href="#local-6989586621679190781"><span class="hs-identifier hs-var">dest_rect</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span>
</span><span id="line-107"></span><span>  </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; a -&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">with</span></span><span> </span><span class="annot"><span class="annottext">Rect
</span><a href="#local-6989586621679190783"><span class="hs-identifier hs-var">src_rect</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679190780"><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190780"><span class="hs-identifier hs-var">ps</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-108"></span><span>  </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; a -&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">with</span></span><span> </span><span class="annot"><span class="annottext">Rect
</span><a href="#local-6989586621679190781"><span class="hs-identifier hs-var">dest_rect</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679190779"><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190779"><span class="hs-identifier hs-var">pd</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span>
</span><span id="line-109"></span><span>  </span><span class="annot"><span class="annottext">Ptr Image -&gt; Ptr Rect -&gt; Ptr Target -&gt; Ptr Rect -&gt; IO ()
</span><a href="SDL.GPU.C.Rendering.html#blitRect"><span class="hs-identifier hs-var">GPU.blitRect</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190784"><span class="hs-identifier hs-var">img</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190780"><span class="hs-identifier hs-var">ps</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679190782"><span class="hs-identifier hs-var">t</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190779"><span class="hs-identifier hs-var">pd</span></a></span><span>
</span><span id="line-110"></span><span>
</span><span id="line-111"></span><span class="annot"><a href="SDL.GPU.Simple.Rendering.html#blitRectX"><span class="hs-identifier hs-type">blitRectX</span></a></span><span>
</span><span id="line-112"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190879"><span class="annot"><a href="#local-6989586621679190879"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-113"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190879"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-114"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-115"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Rect"><span class="hs-identifier hs-type">GPU.Rect</span></a></span><span> </span><span class="hs-comment">-- ^ src_rect</span><span>
</span><span id="line-116"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-117"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Rect"><span class="hs-identifier hs-type">GPU.Rect</span></a></span><span> </span><span class="hs-comment">-- ^ dest_rect</span><span>
</span><span id="line-118"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ degrees</span><span>
</span><span id="line-119"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ pivot_x</span><span>
</span><span id="line-120"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ pivot_y</span><span>
</span><span id="line-121"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#FlipEnum"><span class="hs-identifier hs-type">GPU.FlipEnum</span></a></span><span> </span><span class="hs-comment">-- ^ flip_direction</span><span>
</span><span id="line-122"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190879"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-123"></span><span id="blitRectX"><span class="annot"><span class="annottext">blitRectX :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr Image
-&gt; Rect
-&gt; Ptr Target
-&gt; Rect
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; FlipEnum
-&gt; m ()
</span><a href="SDL.GPU.Simple.Rendering.html#blitRectX"><span class="hs-identifier hs-var hs-var">blitRectX</span></a></span></span><span> </span><span id="local-6989586621679190772"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190772"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679190771"><span class="annot"><span class="annottext">Rect
</span><a href="#local-6989586621679190771"><span class="hs-identifier hs-var">src_rect</span></a></span></span><span> </span><span id="local-6989586621679190770"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679190770"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span id="local-6989586621679190769"><span class="annot"><span class="annottext">Rect
</span><a href="#local-6989586621679190769"><span class="hs-identifier hs-var">dest_rect</span></a></span></span><span> </span><span id="local-6989586621679190768"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190768"><span class="hs-identifier hs-var">d</span></a></span></span><span> </span><span id="local-6989586621679190767"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190767"><span class="hs-identifier hs-var">px</span></a></span></span><span> </span><span id="local-6989586621679190766"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190766"><span class="hs-identifier hs-var">py</span></a></span></span><span> </span><span id="local-6989586621679190765"><span class="annot"><span class="annottext">FlipEnum
</span><a href="#local-6989586621679190765"><span class="hs-identifier hs-var">fd</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span>
</span><span id="line-124"></span><span>  </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; a -&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">with</span></span><span> </span><span class="annot"><span class="annottext">Rect
</span><a href="#local-6989586621679190771"><span class="hs-identifier hs-var">src_rect</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679190764"><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190764"><span class="hs-identifier hs-var">ps</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-125"></span><span>  </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; a -&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">with</span></span><span> </span><span class="annot"><span class="annottext">Rect
</span><a href="#local-6989586621679190769"><span class="hs-identifier hs-var">dest_rect</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679190763"><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190763"><span class="hs-identifier hs-var">pd</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span>
</span><span id="line-126"></span><span>  </span><span class="annot"><span class="annottext">Ptr Image
-&gt; Ptr Rect
-&gt; Ptr Target
-&gt; Ptr Rect
-&gt; Float
-&gt; Float
-&gt; Float
-&gt; FlipEnum
-&gt; IO ()
</span><a href="SDL.GPU.C.Rendering.html#blitRectX"><span class="hs-identifier hs-var">GPU.blitRectX</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190772"><span class="hs-identifier hs-var">img</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190764"><span class="hs-identifier hs-var">ps</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679190770"><span class="hs-identifier hs-var">t</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190763"><span class="hs-identifier hs-var">pd</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190768"><span class="hs-identifier hs-var">d</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190767"><span class="hs-identifier hs-var">px</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190766"><span class="hs-identifier hs-var">py</span></a></span><span> </span><span class="annot"><span class="annottext">FlipEnum
</span><a href="#local-6989586621679190765"><span class="hs-identifier hs-var">fd</span></a></span><span>
</span><span id="line-127"></span><span class="hs-comment">-- TODO triangle/primitive batch</span><span>
</span><span id="line-128"></span><span>
</span><span id="line-129"></span><span class="annot"><a href="SDL.GPU.Simple.Rendering.html#flushBlitBuffer"><span class="hs-identifier hs-type">flushBlitBuffer</span></a></span><span>
</span><span id="line-130"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190876"><span class="annot"><a href="#local-6989586621679190876"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-131"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190876"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-132"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190876"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-133"></span><span id="flushBlitBuffer"><span class="annot"><span class="annottext">flushBlitBuffer :: forall (m :: * -&gt; *). MonadIO m =&gt; m ()
</span><a href="SDL.GPU.Simple.Rendering.html#flushBlitBuffer"><span class="hs-identifier hs-var hs-var">flushBlitBuffer</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">IO ()
</span><a href="SDL.GPU.C.Rendering.html#flushBlitBuffer"><span class="hs-identifier hs-var">GPU.flushBlitBuffer</span></a></span><span>
</span><span id="line-134"></span><span>
</span><span id="line-135"></span><span class="annot"><a href="SDL.GPU.Simple.Rendering.html#flip"><span class="hs-identifier hs-type">flip</span></a></span><span>
</span><span id="line-136"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190756"><span class="annot"><a href="#local-6989586621679190756"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-137"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190756"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-138"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-139"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190756"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-140"></span><span id="flip"><span class="annot"><span class="annottext">flip :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; m ()
</span><a href="SDL.GPU.Simple.Rendering.html#flip"><span class="hs-identifier hs-var hs-var">flip</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; IO ()
</span><a href="SDL.GPU.C.Rendering.html#flip"><span class="hs-identifier hs-var">GPU.flip</span></a></span><span>
</span><span id="line-141"></span></pre></body></html>